##// END OF EJS Templates
erreurs
vidal -
r720:4b2455eecc9a
parent child
Show More
@@ -1,919 +1,902
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47 if [ $RELEASE = "bullseye" ] ; then
48 48 RELEASE=testing
49 49 fi
50 50
51 51 # Kernel Branch
52 52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 53
54 54 # URLs
55 55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 64
65 65 # Kernel deb packages for 32bit kernel
66 66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
70 70 # Default precompiled 64bit kernel
71 71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
72 72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
74 74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
76 76 # Generic
77 77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 81
82 82 # Build directories
83 83 WORKDIR=$(pwd)
84 84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 85 BUILDDIR="${BASEDIR}/build"
86 86
87 87 # Chroot directories
88 88 R="${BUILDDIR}/chroot"
89 89 ETC_DIR="${R}/etc"
90 90 LIB_DIR="${R}/lib"
91 91 BOOT_DIR="${R}/boot/firmware"
92 92 KERNEL_DIR="${R}/usr/src/linux"
93 93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 95
96 96 # Firmware directory: Blank if download from github
97 97 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
98 98
99 99 # General settings
100 100 SET_ARCH=${SET_ARCH:=32}
101 101 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
102 102 PASSWORD=${PASSWORD:=raspberry}
103 103 USER_PASSWORD=${USER_PASSWORD:=raspberry}
104 104 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
105 105 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
106 106 EXPANDROOT=${EXPANDROOT:=true}
107 107 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
108 108
109 109 # Keyboard settings
110 110 XKB_MODEL=${XKB_MODEL:=""}
111 111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 112 XKB_VARIANT=${XKB_VARIANT:=""}
113 113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114 114
115 115 # Network settings (DHCP)
116 116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117 117
118 118 # Network settings (static)
119 119 NET_ADDRESS=${NET_ADDRESS:=""}
120 120 NET_GATEWAY=${NET_GATEWAY:=""}
121 121 NET_DNS_1=${NET_DNS_1:=""}
122 122 NET_DNS_2=${NET_DNS_2:=""}
123 123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 124 NET_NTP_1=${NET_NTP_1:=""}
125 125 NET_NTP_2=${NET_NTP_2:=""}
126 126
127 127 # APT settings
128 128 APT_PROXY=${APT_PROXY:=""}
129 129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 130 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
131 131
132 132 # Feature settings
133 133 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
134 134 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
135 135 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
136 136 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
137 137 ENABLE_I2C=${ENABLE_I2C:=false}
138 138 ENABLE_SPI=${ENABLE_SPI:=false}
139 139 ENABLE_IPV6=${ENABLE_IPV6:=true}
140 140 ENABLE_SSHD=${ENABLE_SSHD:=true}
141 141 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
142 142 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
143 143 ENABLE_SOUND=${ENABLE_SOUND:=true}
144 144 ENABLE_DBUS=${ENABLE_DBUS:=true}
145 145 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
146 146 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
147 147 ENABLE_XORG=${ENABLE_XORG:=false}
148 148 ENABLE_WM=${ENABLE_WM:=""}
149 149 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
150 150 ENABLE_USER=${ENABLE_USER:=true}
151 151 USER_NAME=${USER_NAME:="pi"}
152 152 ENABLE_ROOT=${ENABLE_ROOT:=false}
153 153 ENABLE_QEMU=${ENABLE_QEMU:=false}
154 154 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
155 155
156 156 # SSH settings
157 157 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
158 158 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
159 159 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
160 160 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
161 161 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
162 162
163 163 # Advanced settings
164 164 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
165 165 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
166 166 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
167 167 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
168 168 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
169 169 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
170 170 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
171 171 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
172 172 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
173 173 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
174 174 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
175 175 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
176 176 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
177 177 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
178 178 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
179 179 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
180 180 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
181 181 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
182 182 ENABLE_LOGO=${ENABLE_LOGO:=true}
183 183 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
184 184 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
185 185
186 186 # Kernel compilation settings
187 187 BUILD_KERNEL=${BUILD_KERNEL:=true}
188 188 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
189 189 KERNEL_THREADS=${KERNEL_THREADS:=1}
190 190 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
191 191 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
192 192 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
193 193 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
194 194 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
195 195 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
196 196 KERNEL_VIRT=${KERNEL_VIRT:=false}
197 197 KERNEL_BPF=${KERNEL_BPF:=false}
198 198 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
199 199 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
200 200 KERNEL_NF=${KERNEL_NF:=false}
201 201 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
202 202 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
203 203 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
204 204 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
205 205
206 206 # Kernel compilation from source directory settings
207 207 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
208 208 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
209 209 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
210 210 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
211 211
212 212 # Reduce disk usage settings
213 213 REDUCE_APT=${REDUCE_APT:=true}
214 214 REDUCE_DOC=${REDUCE_DOC:=true}
215 215 REDUCE_MAN=${REDUCE_MAN:=true}
216 216 REDUCE_VIM=${REDUCE_VIM:=false}
217 217 REDUCE_BASH=${REDUCE_BASH:=false}
218 218 REDUCE_HWDB=${REDUCE_HWDB:=true}
219 219 REDUCE_SSHD=${REDUCE_SSHD:=true}
220 220 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
221 221
222 222 # Encrypted filesystem settings
223 223 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
224 224 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
225 225 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
226 226 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
227 227 CRYPTFS_HASH=${CRYPTFS_HASH:="sha512"}
228 228 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
229 229 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
230 230 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
231 231 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
232 232 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
233 233
234 234 # Chroot scripts directory
235 235 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
236 236
237 237 # Packages required in the chroot build environment
238 238 APT_INCLUDES=${APT_INCLUDES:=""}
239 239
240 240 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
241 241
242 242 # Packages to exclude from chroot build environment
243 243 APT_EXCLUDES=${APT_EXCLUDES:=""}
244 244
245 245 # Packages required for bootstrapping
246 246
247 247 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
248 248 MISSING_PACKAGES=""
249 249
250 250 # Packages installed for c/c++ build environment in chroot (keep empty)
251 251 COMPILER_PACKAGES=""
252 252
253 253 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
254 254 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
255 255 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
256 256 APT_PROXY=http://127.0.0.1:3142/
257 257 fi
258 258
259 259 # Setup architecture specific settings
260 260 if [ -n "$SET_ARCH" ] ; then
261 261 # 64-bit configuration
262 262 if [ "$SET_ARCH" = 64 ] ; then
263 263 # General 64-bit depended settings
264 264 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
265 265 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
266 266 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
267 267
268 268 # Raspberry Pi model specific settings
269 269 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
270 270 if [ "$RPI_MODEL" != 4 ] ; then
271 271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
272 272 else
273 273 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
274 274 fi
275 275
276 276 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
277 277 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
278 278 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
279 279 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
280 280 else
281 281 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
282 282 exit 1
283 283 fi
284 284 fi
285 285
286 286 # 32-bit configuration
287 287 if [ "$SET_ARCH" = 32 ] ; then
288 288 # General 32-bit dependend settings
289 289 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
290 290 KERNEL_ARCH=${KERNEL_ARCH:=arm}
291 291 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
292 292
293 293 # Raspberry Pi model specific settings
294 294 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
295 295 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
296 296 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
297 297 RELEASE_ARCH=${RELEASE_ARCH:=armel}
298 298 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
299 299 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
300 300 fi
301 301
302 302 # Raspberry Pi model specific settings
303 303 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
304 304 if [ "$RPI_MODEL" != 4 ] ; then
305 305 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
306 306 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
307 307 else
308 308 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
309 309 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
310 310 fi
311 311
312 312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
313 313 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
314 <<<<<<< HEAD
315 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
316 =======
317 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
318 314
319 315 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
320 316 fi
321 317 fi
322 318 # SET_ARCH not set
323 319 else
324 320 echo "error: Please set '32' or '64' as value for SET_ARCH"
325 321 exit 1
326 322 fi
327 323 # Device specific configuration and U-Boot configuration
328 324 case "$RPI_MODEL" in
329 325 0)
330 326 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
331 327 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
332 328 ;;
333 329 1)
334 330 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
335 331 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
336 332 ;;
337 333 1P)
338 334 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
339 335 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
340 336 ;;
341 337 2)
342 338 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
343 339 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
344 340 ;;
345 341 3)
346 342 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
347 343 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
348 344 ;;
349 345 3P)
350 346 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
351 347 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
352 348 ;;
353 349 4)
354 350 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
355 351 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
356 352 ;;
357 353 *)
358 354 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
359 355 exit 1
360 356 ;;
361 357 esac
362 358
363 359 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
364 360 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
365 361 # Include bluetooth packages on supported boards
366 362 if [ "$ENABLE_BLUETOOTH" = true ] ; then
367 363 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
368 364 fi
369 365 if [ "$ENABLE_WIRELESS" = true ] ; then
370 366 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
371 367 fi
372 368 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
373 369 # Check if the internal wireless interface is not supported by the RPi model
374 370 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
375 371 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
376 372 exit 1
377 373 fi
378 374 fi
379 375
380 376 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
381 377 echo "error: You have to compile kernel sources, if you want to enable nexmon"
382 378 exit 1
383 379 fi
384 380
385 381 # Prepare date string for default image file name
386 382 DATE="$(date +%Y-%m-%d)"
387 383 if [ -z "$KERNEL_BRANCH" ] ; then
388 384 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
389 385 else
390 386 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
391 387 fi
392 388
393 389 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
394 390 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
395 391 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
396 392 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
397 393 exit 1
398 394 fi
399 395 fi
400 396
401 397 # Add cmake to compile videocore sources
402 398 if [ "$ENABLE_VIDEOCORE" = true ] ; then
403 399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
404 400 fi
405 401
406 402 # Add deps for nexmon
407 403 if [ "$ENABLE_NEXMON" = true ] ; then
408 <<<<<<< HEAD
404
409 405 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
410 =======
411 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
412 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
413 406 fi
414 407
415 408 # Add libncurses5 to enable kernel menuconfig
416 409 if [ "$KERNEL_MENUCONFIG" = true ] ; then
417 410 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
418 411 fi
419 412
420 413 # Add ccache compiler cache for (faster) kernel cross (re)compilation
421 414 if [ "$KERNEL_CCACHE" = true ] ; then
422 415 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
423 416 fi
424 417
425 418 # Add cryptsetup package to enable filesystem encryption
426 419 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
427 420 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
428 <<<<<<< HEAD
429 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
430 =======
431 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
421
432 422 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
433 423
434 424 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
435 425 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
436 426 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
437 427 fi
438 428
439 429 if [ -z "$CRYPTFS_PASSWORD" ] ; then
440 430 echo "error: no password defined (CRYPTFS_PASSWORD)!"
441 431 exit 1
442 432 fi
443 433 ENABLE_INITRAMFS=true
444 434 fi
445 435
446 436 # Add initramfs generation tools
447 437 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
448 438 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
449 439 fi
450 440
451 441 # Add device-tree-compiler required for building the U-Boot bootloader
452 442 if [ "$ENABLE_UBOOT" = true ] ; then
453 443 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
454 444 fi
455 445
456 446 if [ "$ENABLE_USBBOOT" = true ] ; then
457 447 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
458 448 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
459 449 exit 1
460 450 fi
461 451 fi
462 452
463 453 # Check if root SSH (v2) public key file exists
464 454 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
465 455 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
466 456 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
467 457 exit 1
468 458 fi
469 459 fi
470 460
471 461 # Check if $USER_NAME SSH (v2) public key file exists
472 462 if [ -n "$SSH_USER_PUB_KEY" ] ; then
473 463 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
474 464 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
475 465 exit 1
476 466 fi
477 467 fi
478 468
479 469 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
480 470 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
481 471 exit 1
482 472 fi
483 473
484 474 # Check if all required packages are installed on the build system
485 475 for package in $REQUIRED_PACKAGES ; do
486 476 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
487 477 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
488 478 fi
489 479 done
490 480
491 481 # If there are missing packages ask confirmation for install, or exit
492 482 if [ -n "$MISSING_PACKAGES" ] ; then
493 483 echo "the following packages needed by this script are not installed:"
494 484 echo "$MISSING_PACKAGES"
495 485
496 486 printf "\ndo you want to install the missing packages right now? [y/n] "
497 487 read -r confirm
498 488 [ "$confirm" != "y" ] && exit 1
499 489
500 490 # Make sure all missing required packages are installed
501 <<<<<<< HEAD
502 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
503 =======
504 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
505 491 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
506 492 fi
507 493
508 494 # Check if ./bootstrap.d directory exists
509 495 if [ ! -d "./bootstrap.d/" ] ; then
510 496 echo "error: './bootstrap.d' required directory not found!"
511 497 exit 1
512 498 fi
513 499
514 500 # Check if ./files directory exists
515 501 if [ ! -d "./files/" ] ; then
516 502 echo "error: './files' required directory not found!"
517 503 exit 1
518 504 fi
519 505
520 506 # Check if specified KERNELSRC_DIR directory exists
521 507 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
522 508 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
523 509 exit 1
524 510 fi
525 511
526 512 # Check if specified UBOOTSRC_DIR directory exists
527 513 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
528 514 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
529 515 exit 1
530 516 fi
531 517
532 518 # Check if specified VIDEOCORESRC_DIR directory exists
533 519 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
534 520 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
535 521 exit 1
536 522 fi
537 523
538 524 # Check if specified FBTURBOSRC_DIR directory exists
539 525 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
540 526 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
541 527 exit 1
542 528 fi
543 529
544 530 # Check if specified NEXMONSRC_DIR directory exists
545 531 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
546 532 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
547 533 exit 1
548 534 fi
549 535
550 536 # Check if specified CHROOT_SCRIPTS directory exists
551 537 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
552 538 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
553 539 exit 1
554 540 fi
555 541
556 542 # Check if specified device mapping already exists (will be used by cryptsetup)
557 543 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
558 544 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
559 545 exit 1
560 546 fi
561 547
562 548 # Don't clobber an old build
563 549 if [ -e "$BUILDDIR" ] ; then
564 550 echo "error: directory ${BUILDDIR} already exists, not proceeding"
565 551 exit 1
566 552 fi
567 553
568 554 # Setup chroot directory
569 555 mkdir -p "${R}"
570 556
571 557 # Check if build directory has enough of free disk space >512MB
572 558 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
573 559 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
574 560 exit 1
575 561 fi
576 562
577 563 set -x
578 564
579 565 # Call "cleanup" function on various signals and errors
580 566 trap cleanup 0 1 2 3 6
581 567
582 568 # Add required packages for the minbase installation
583 569 if [ "$ENABLE_MINBASE" = true ] ; then
584 570 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
585 571 fi
586 572
587 573 # Add parted package, required to get partprobe utility
588 574 if [ "$EXPANDROOT" = true ] ; then
589 575 APT_INCLUDES="${APT_INCLUDES},parted"
590 576 fi
591 577
592 578 # Add dphys-swapfile package, required to enable swap
593 579 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
594 580 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
595 581 fi
596 582
597 583 # Add dbus package, recommended if using systemd
598 584 if [ "$ENABLE_DBUS" = true ] ; then
599 585 APT_INCLUDES="${APT_INCLUDES},dbus"
600 586 fi
601 587
602 588 # Add iptables IPv4/IPv6 package
603 589 if [ "$ENABLE_IPTABLES" = true ] ; then
604 590 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
605 591 fi
606 592 # Add apparmor for KERNEL_SECURITY
607 593 if [ "$KERNEL_SECURITY" = true ] ; then
608 594 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
609 595 fi
610 596
611 597 # Add openssh server package
612 598 if [ "$ENABLE_SSHD" = true ] ; then
613 599 APT_INCLUDES="${APT_INCLUDES},openssh-server"
614 600 fi
615 601
616 602 # Add alsa-utils package
617 603 if [ "$ENABLE_SOUND" = true ] ; then
618 604 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
619 605 fi
620 606
621 607 # Add rng-tools package
622 608 if [ "$ENABLE_HWRANDOM" = true ] ; then
623 609 APT_INCLUDES="${APT_INCLUDES},rng-tools"
624 610 fi
625 611
626 612 # Add fbturbo video driver
627 613 if [ "$ENABLE_FBTURBO" = true ] ; then
628 614 # Enable xorg package dependencies
629 615 ENABLE_XORG=true
630 616 fi
631 617
632 618 # Add user defined window manager package
633 619 if [ -n "$ENABLE_WM" ] ; then
634 620 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
635 621
636 622 # Enable xorg package dependencies
637 623 ENABLE_XORG=true
638 624 fi
639 625
640 626 # Add xorg package
641 627 if [ "$ENABLE_XORG" = true ] ; then
642 628 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
643 629 fi
644 630
645 631 # Replace selected packages with smaller clones
646 632 if [ "$ENABLE_REDUCE" = true ] ; then
647 633 # Add levee package instead of vim-tiny
648 634 if [ "$REDUCE_VIM" = true ] ; then
649 635 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
650 636 fi
651 637
652 638 # Add dropbear package instead of openssh-server
653 639 if [ "$REDUCE_SSHD" = true ] ; then
654 640 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
655 641 fi
656 642 fi
657 643
658 644 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
659 645 if [ "$ENABLE_SYSVINIT" = false ] ; then
660 646 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
661 647 fi
662 648
663 649 # Configure kernel sources if no KERNELSRC_DIR
664 650 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
665 651 KERNELSRC_CONFIG=true
666 652 fi
667 653
668 654 # Configure reduced kernel
669 655 if [ "$KERNEL_REDUCE" = true ] ; then
670 656 KERNELSRC_CONFIG=false
671 657 fi
672 658
673 659 # Configure qemu compatible kernel
674 660 if [ "$ENABLE_QEMU" = true ] ; then
675 661 DTB_FILE=vexpress-v2p-ca15_a7.dtb
676 662 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
677 663 KERNEL_DEFCONFIG="vexpress_defconfig"
678 664 if [ "$KERNEL_MENUCONFIG" = false ] ; then
679 665 KERNEL_OLDDEFCONFIG=true
680 666 fi
681 667 fi
682 668
683 669 # Execute bootstrap scripts
684 670 for SCRIPT in bootstrap.d/*.sh; do
685 671 head -n 3 "$SCRIPT"
686 672 . "$SCRIPT"
687 673 done
688 674
689 675 ## Execute custom bootstrap scripts
690 676 if [ -d "custom.d" ] ; then
691 677 for SCRIPT in custom.d/*.sh; do
692 678 . "$SCRIPT"
693 679 done
694 680 fi
695 681
696 682 # Execute custom scripts inside the chroot
697 683 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
698 684 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
699 685 chroot_exec /bin/bash -x <<'EOF'
700 686 for SCRIPT in /chroot_scripts/* ; do
701 687 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
702 688 $SCRIPT
703 689 fi
704 690 done
705 691 EOF
706 692 rm -rf "${R}/chroot_scripts"
707 693 fi
708 694
709 695 # Remove c/c++ build environment from the chroot
710 696 chroot_remove_cc
711 697
712 698 # Generate required machine-id
713 699 MACHINE_ID=$(dbus-uuidgen)
714 700 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
715 701 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
716 702
717 703 # APT Cleanup
718 704 chroot_exec apt-get -y clean
719 705 chroot_exec apt-get -y autoclean
720 706 chroot_exec apt-get -y autoremove
721 707
722 708 # Unmount mounted filesystems
723 709 umount -l "${R}/proc"
724 710 umount -l "${R}/sys"
725 711
726 712 # Clean up directories
727 713 rm -rf "${R}/run/*"
728 714 rm -rf "${R}/tmp/*"
729 715
730 716 # Clean up APT proxy settings
731 717 if [ "$KEEP_APT_PROXY" = false ] ; then
732 718 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
733 719 fi
734 720
735 721 # Clean up files
736 722 rm -f "${ETC_DIR}/ssh/ssh_host_*"
737 723 rm -f "${ETC_DIR}/dropbear/dropbear_*"
738 724 rm -f "${ETC_DIR}/apt/sources.list.save"
739 725 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
740 726 rm -f "${ETC_DIR}/*-"
741 727 rm -f "${ETC_DIR}/resolv.conf"
742 728 rm -f "${R}/root/.bash_history"
743 729 rm -f "${R}/var/lib/urandom/random-seed"
744 730 rm -f "${R}/initrd.img"
745 731 rm -f "${R}/vmlinuz"
746 732 rm -f "${R}${QEMU_BINARY}"
747 733
748 734 if [ "$ENABLE_QEMU" = true ] ; then
749 735 # Setup QEMU directory
750 736 mkdir "${BASEDIR}/qemu"
751 737
752 738 # Copy kernel image to QEMU directory
753 739 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
754 740
755 741 # Copy kernel config to QEMU directory
756 742 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
757 743
758 744 # Copy kernel dtbs to QEMU directory
759 745 for dtb in "${BOOT_DIR}/"*.dtb ; do
760 746 if [ -f "${dtb}" ] ; then
761 747 install_readonly "${dtb}" "${BASEDIR}/qemu/"
762 748 fi
763 749 done
764 750
765 751 # Copy kernel overlays to QEMU directory
766 752 if [ -d "${BOOT_DIR}/overlays" ] ; then
767 753 # Setup overlays dtbs directory
768 754 mkdir "${BASEDIR}/qemu/overlays"
769 755
770 756 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
771 757 if [ -f "${dtb}" ] ; then
772 758 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
773 759 fi
774 760 done
775 761 fi
776 762
777 763 # Copy u-boot files to QEMU directory
778 764 if [ "$ENABLE_UBOOT" = true ] ; then
779 765 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
780 766 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
781 767 fi
782 768 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
783 769 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
784 770 fi
785 771 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
786 772 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
787 773 fi
788 774 fi
789 775
790 776 # Copy initramfs to QEMU directory
791 777 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
792 778 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
793 779 fi
794 780 fi
795 781
796 782 # Calculate size of the chroot directory in KB
797 783 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
798 784
799 785 # Calculate the amount of needed 512 Byte sectors
800 786 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
801 787 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
802 788 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
803 789
804 790 # The root partition is EXT4
805 791 # This means more space than the actual used space of the chroot is used.
806 792 # As overhead for journaling and reserved blocks 35% are added.
807 793 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
808 794
809 795 # Calculate required image size in 512 Byte sectors
810 796 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
811 797
812 798 # Prepare image file
813 799 if [ "$ENABLE_SPLITFS" = true ] ; then
814 800 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
815 801 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
816 802 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
817 803 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
818 804
819 805 # Write firmware/boot partition tables
820 806 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
821 807 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
822 808 EOM
823 809
824 810 # Write root partition table
825 811 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
826 812 ${TABLE_SECTORS},${ROOT_SECTORS},83
827 813 EOM
828 814
829 815 # Setup temporary loop devices
830 816 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
831 817 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
832 818 else # ENABLE_SPLITFS=false
833 819 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
834 820 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
835 821
836 822 # Write partition table
837 823 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
838 824 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
839 825 ${ROOT_OFFSET},${ROOT_SECTORS},83
840 826 EOM
841 827
842 828 # Setup temporary loop devices
843 829 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
844 830 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
845 831 fi
846 832
847 833 if [ "$ENABLE_CRYPTFS" = true ] ; then
848 834 # Create dummy ext4 fs
849 835 mkfs.ext4 "$ROOT_LOOP"
850 836
851 837 # Setup password keyfile
852 838 touch .password
853 839 chmod 600 .password
854 840 echo -n ${CRYPTFS_PASSWORD} > .password
855 841
856 842 # Initialize encrypted partition
857 <<<<<<< HEAD
858 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
859 =======
860 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
843
861 844 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
862 845
863 846 # Open encrypted partition and setup mapping
864 847 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
865 848
866 849 # Secure delete password keyfile
867 850 shred -zu .password
868 851
869 852 # Update temporary loop device
870 853 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
871 854
872 855 # Wipe encrypted partition (encryption cipher is used for randomness)
873 856 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
874 857 fi
875 858
876 859 # Build filesystems
877 860 mkfs.vfat "$FRMW_LOOP"
878 861 mkfs.ext4 "$ROOT_LOOP"
879 862
880 863 # Mount the temporary loop devices
881 864 mkdir -p "$BUILDDIR/mount"
882 865 mount "$ROOT_LOOP" "$BUILDDIR/mount"
883 866
884 867 mkdir -p "$BUILDDIR/mount/boot/firmware"
885 868 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
886 869
887 870 # Copy all files from the chroot to the loop device mount point directory
888 871 rsync -a "${R}/" "$BUILDDIR/mount/"
889 872
890 873 # Unmount all temporary loop devices and mount points
891 874 cleanup
892 875
893 876 # Create block map file(s) of image(s)
894 877 if [ "$ENABLE_SPLITFS" = true ] ; then
895 878 # Create block map files for "bmaptool"
896 879 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
897 880 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
898 881
899 882 # Image was successfully created
900 883 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
901 884 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
902 885 else
903 886 # Create block map file for "bmaptool"
904 887 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
905 888
906 889 # Image was successfully created
907 890 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
908 891
909 892 # Create qemu qcow2 image
910 893 if [ "$ENABLE_QEMU" = true ] ; then
911 894 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
912 895 QEMU_SIZE=16G
913 896
914 897 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
915 898 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
916 899
917 900 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
918 901 fi
919 902 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant